// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from grbl_msgs:action/SendGcodeFile.idl
// generated code does not contain a copyright notice

#ifndef GRBL_MSGS__ACTION__DETAIL__SEND_GCODE_FILE__STRUCT_HPP_
#define GRBL_MSGS__ACTION__DETAIL__SEND_GCODE_FILE__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


#ifndef _WIN32
# define DEPRECATED__grbl_msgs__action__SendGcodeFile_Goal __attribute__((deprecated))
#else
# define DEPRECATED__grbl_msgs__action__SendGcodeFile_Goal __declspec(deprecated)
#endif

namespace grbl_msgs
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct SendGcodeFile_Goal_
{
  using Type = SendGcodeFile_Goal_<ContainerAllocator>;

  explicit SendGcodeFile_Goal_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->file_path = "";
    }
  }

  explicit SendGcodeFile_Goal_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : file_path(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->file_path = "";
    }
  }

  // field types and members
  using _file_path_type =
    std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>;
  _file_path_type file_path;

  // setters for named parameter idiom
  Type & set__file_path(
    const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> & _arg)
  {
    this->file_path = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    grbl_msgs::action::SendGcodeFile_Goal_<ContainerAllocator> *;
  using ConstRawPtr =
    const grbl_msgs::action::SendGcodeFile_Goal_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<grbl_msgs::action::SendGcodeFile_Goal_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<grbl_msgs::action::SendGcodeFile_Goal_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      grbl_msgs::action::SendGcodeFile_Goal_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<grbl_msgs::action::SendGcodeFile_Goal_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      grbl_msgs::action::SendGcodeFile_Goal_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<grbl_msgs::action::SendGcodeFile_Goal_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<grbl_msgs::action::SendGcodeFile_Goal_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<grbl_msgs::action::SendGcodeFile_Goal_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__grbl_msgs__action__SendGcodeFile_Goal
    std::shared_ptr<grbl_msgs::action::SendGcodeFile_Goal_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__grbl_msgs__action__SendGcodeFile_Goal
    std::shared_ptr<grbl_msgs::action::SendGcodeFile_Goal_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SendGcodeFile_Goal_ & other) const
  {
    if (this->file_path != other.file_path) {
      return false;
    }
    return true;
  }
  bool operator!=(const SendGcodeFile_Goal_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SendGcodeFile_Goal_

// alias to use template instance with default allocator
using SendGcodeFile_Goal =
  grbl_msgs::action::SendGcodeFile_Goal_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace grbl_msgs


#ifndef _WIN32
# define DEPRECATED__grbl_msgs__action__SendGcodeFile_Result __attribute__((deprecated))
#else
# define DEPRECATED__grbl_msgs__action__SendGcodeFile_Result __declspec(deprecated)
#endif

namespace grbl_msgs
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct SendGcodeFile_Result_
{
  using Type = SendGcodeFile_Result_<ContainerAllocator>;

  explicit SendGcodeFile_Result_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->success = false;
    }
  }

  explicit SendGcodeFile_Result_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->success = false;
    }
  }

  // field types and members
  using _success_type =
    bool;
  _success_type success;

  // setters for named parameter idiom
  Type & set__success(
    const bool & _arg)
  {
    this->success = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    grbl_msgs::action::SendGcodeFile_Result_<ContainerAllocator> *;
  using ConstRawPtr =
    const grbl_msgs::action::SendGcodeFile_Result_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<grbl_msgs::action::SendGcodeFile_Result_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<grbl_msgs::action::SendGcodeFile_Result_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      grbl_msgs::action::SendGcodeFile_Result_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<grbl_msgs::action::SendGcodeFile_Result_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      grbl_msgs::action::SendGcodeFile_Result_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<grbl_msgs::action::SendGcodeFile_Result_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<grbl_msgs::action::SendGcodeFile_Result_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<grbl_msgs::action::SendGcodeFile_Result_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__grbl_msgs__action__SendGcodeFile_Result
    std::shared_ptr<grbl_msgs::action::SendGcodeFile_Result_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__grbl_msgs__action__SendGcodeFile_Result
    std::shared_ptr<grbl_msgs::action::SendGcodeFile_Result_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SendGcodeFile_Result_ & other) const
  {
    if (this->success != other.success) {
      return false;
    }
    return true;
  }
  bool operator!=(const SendGcodeFile_Result_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SendGcodeFile_Result_

// alias to use template instance with default allocator
using SendGcodeFile_Result =
  grbl_msgs::action::SendGcodeFile_Result_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace grbl_msgs


#ifndef _WIN32
# define DEPRECATED__grbl_msgs__action__SendGcodeFile_Feedback __attribute__((deprecated))
#else
# define DEPRECATED__grbl_msgs__action__SendGcodeFile_Feedback __declspec(deprecated)
#endif

namespace grbl_msgs
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct SendGcodeFile_Feedback_
{
  using Type = SendGcodeFile_Feedback_<ContainerAllocator>;

  explicit SendGcodeFile_Feedback_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->status = "";
    }
  }

  explicit SendGcodeFile_Feedback_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : status(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->status = "";
    }
  }

  // field types and members
  using _status_type =
    std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>;
  _status_type status;

  // setters for named parameter idiom
  Type & set__status(
    const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> & _arg)
  {
    this->status = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    grbl_msgs::action::SendGcodeFile_Feedback_<ContainerAllocator> *;
  using ConstRawPtr =
    const grbl_msgs::action::SendGcodeFile_Feedback_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<grbl_msgs::action::SendGcodeFile_Feedback_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<grbl_msgs::action::SendGcodeFile_Feedback_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      grbl_msgs::action::SendGcodeFile_Feedback_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<grbl_msgs::action::SendGcodeFile_Feedback_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      grbl_msgs::action::SendGcodeFile_Feedback_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<grbl_msgs::action::SendGcodeFile_Feedback_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<grbl_msgs::action::SendGcodeFile_Feedback_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<grbl_msgs::action::SendGcodeFile_Feedback_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__grbl_msgs__action__SendGcodeFile_Feedback
    std::shared_ptr<grbl_msgs::action::SendGcodeFile_Feedback_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__grbl_msgs__action__SendGcodeFile_Feedback
    std::shared_ptr<grbl_msgs::action::SendGcodeFile_Feedback_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SendGcodeFile_Feedback_ & other) const
  {
    if (this->status != other.status) {
      return false;
    }
    return true;
  }
  bool operator!=(const SendGcodeFile_Feedback_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SendGcodeFile_Feedback_

// alias to use template instance with default allocator
using SendGcodeFile_Feedback =
  grbl_msgs::action::SendGcodeFile_Feedback_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace grbl_msgs


// Include directives for member types
// Member 'goal_id'
#include "unique_identifier_msgs/msg/detail/uuid__struct.hpp"
// Member 'goal'
#include "grbl_msgs/action/detail/send_gcode_file__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__grbl_msgs__action__SendGcodeFile_SendGoal_Request __attribute__((deprecated))
#else
# define DEPRECATED__grbl_msgs__action__SendGcodeFile_SendGoal_Request __declspec(deprecated)
#endif

namespace grbl_msgs
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct SendGcodeFile_SendGoal_Request_
{
  using Type = SendGcodeFile_SendGoal_Request_<ContainerAllocator>;

  explicit SendGcodeFile_SendGoal_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : goal_id(_init),
    goal(_init)
  {
    (void)_init;
  }

  explicit SendGcodeFile_SendGoal_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : goal_id(_alloc, _init),
    goal(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _goal_id_type =
    unique_identifier_msgs::msg::UUID_<ContainerAllocator>;
  _goal_id_type goal_id;
  using _goal_type =
    grbl_msgs::action::SendGcodeFile_Goal_<ContainerAllocator>;
  _goal_type goal;

  // setters for named parameter idiom
  Type & set__goal_id(
    const unique_identifier_msgs::msg::UUID_<ContainerAllocator> & _arg)
  {
    this->goal_id = _arg;
    return *this;
  }
  Type & set__goal(
    const grbl_msgs::action::SendGcodeFile_Goal_<ContainerAllocator> & _arg)
  {
    this->goal = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    grbl_msgs::action::SendGcodeFile_SendGoal_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const grbl_msgs::action::SendGcodeFile_SendGoal_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<grbl_msgs::action::SendGcodeFile_SendGoal_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<grbl_msgs::action::SendGcodeFile_SendGoal_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      grbl_msgs::action::SendGcodeFile_SendGoal_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<grbl_msgs::action::SendGcodeFile_SendGoal_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      grbl_msgs::action::SendGcodeFile_SendGoal_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<grbl_msgs::action::SendGcodeFile_SendGoal_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<grbl_msgs::action::SendGcodeFile_SendGoal_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<grbl_msgs::action::SendGcodeFile_SendGoal_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__grbl_msgs__action__SendGcodeFile_SendGoal_Request
    std::shared_ptr<grbl_msgs::action::SendGcodeFile_SendGoal_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__grbl_msgs__action__SendGcodeFile_SendGoal_Request
    std::shared_ptr<grbl_msgs::action::SendGcodeFile_SendGoal_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SendGcodeFile_SendGoal_Request_ & other) const
  {
    if (this->goal_id != other.goal_id) {
      return false;
    }
    if (this->goal != other.goal) {
      return false;
    }
    return true;
  }
  bool operator!=(const SendGcodeFile_SendGoal_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SendGcodeFile_SendGoal_Request_

// alias to use template instance with default allocator
using SendGcodeFile_SendGoal_Request =
  grbl_msgs::action::SendGcodeFile_SendGoal_Request_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace grbl_msgs


// Include directives for member types
// Member 'stamp'
#include "builtin_interfaces/msg/detail/time__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__grbl_msgs__action__SendGcodeFile_SendGoal_Response __attribute__((deprecated))
#else
# define DEPRECATED__grbl_msgs__action__SendGcodeFile_SendGoal_Response __declspec(deprecated)
#endif

namespace grbl_msgs
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct SendGcodeFile_SendGoal_Response_
{
  using Type = SendGcodeFile_SendGoal_Response_<ContainerAllocator>;

  explicit SendGcodeFile_SendGoal_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : stamp(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->accepted = false;
    }
  }

  explicit SendGcodeFile_SendGoal_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : stamp(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->accepted = false;
    }
  }

  // field types and members
  using _accepted_type =
    bool;
  _accepted_type accepted;
  using _stamp_type =
    builtin_interfaces::msg::Time_<ContainerAllocator>;
  _stamp_type stamp;

  // setters for named parameter idiom
  Type & set__accepted(
    const bool & _arg)
  {
    this->accepted = _arg;
    return *this;
  }
  Type & set__stamp(
    const builtin_interfaces::msg::Time_<ContainerAllocator> & _arg)
  {
    this->stamp = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    grbl_msgs::action::SendGcodeFile_SendGoal_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const grbl_msgs::action::SendGcodeFile_SendGoal_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<grbl_msgs::action::SendGcodeFile_SendGoal_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<grbl_msgs::action::SendGcodeFile_SendGoal_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      grbl_msgs::action::SendGcodeFile_SendGoal_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<grbl_msgs::action::SendGcodeFile_SendGoal_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      grbl_msgs::action::SendGcodeFile_SendGoal_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<grbl_msgs::action::SendGcodeFile_SendGoal_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<grbl_msgs::action::SendGcodeFile_SendGoal_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<grbl_msgs::action::SendGcodeFile_SendGoal_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__grbl_msgs__action__SendGcodeFile_SendGoal_Response
    std::shared_ptr<grbl_msgs::action::SendGcodeFile_SendGoal_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__grbl_msgs__action__SendGcodeFile_SendGoal_Response
    std::shared_ptr<grbl_msgs::action::SendGcodeFile_SendGoal_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SendGcodeFile_SendGoal_Response_ & other) const
  {
    if (this->accepted != other.accepted) {
      return false;
    }
    if (this->stamp != other.stamp) {
      return false;
    }
    return true;
  }
  bool operator!=(const SendGcodeFile_SendGoal_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SendGcodeFile_SendGoal_Response_

// alias to use template instance with default allocator
using SendGcodeFile_SendGoal_Response =
  grbl_msgs::action::SendGcodeFile_SendGoal_Response_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace grbl_msgs

namespace grbl_msgs
{

namespace action
{

struct SendGcodeFile_SendGoal
{
  using Request = grbl_msgs::action::SendGcodeFile_SendGoal_Request;
  using Response = grbl_msgs::action::SendGcodeFile_SendGoal_Response;
};

}  // namespace action

}  // namespace grbl_msgs


// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__grbl_msgs__action__SendGcodeFile_GetResult_Request __attribute__((deprecated))
#else
# define DEPRECATED__grbl_msgs__action__SendGcodeFile_GetResult_Request __declspec(deprecated)
#endif

namespace grbl_msgs
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct SendGcodeFile_GetResult_Request_
{
  using Type = SendGcodeFile_GetResult_Request_<ContainerAllocator>;

  explicit SendGcodeFile_GetResult_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : goal_id(_init)
  {
    (void)_init;
  }

  explicit SendGcodeFile_GetResult_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : goal_id(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _goal_id_type =
    unique_identifier_msgs::msg::UUID_<ContainerAllocator>;
  _goal_id_type goal_id;

  // setters for named parameter idiom
  Type & set__goal_id(
    const unique_identifier_msgs::msg::UUID_<ContainerAllocator> & _arg)
  {
    this->goal_id = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    grbl_msgs::action::SendGcodeFile_GetResult_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const grbl_msgs::action::SendGcodeFile_GetResult_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<grbl_msgs::action::SendGcodeFile_GetResult_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<grbl_msgs::action::SendGcodeFile_GetResult_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      grbl_msgs::action::SendGcodeFile_GetResult_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<grbl_msgs::action::SendGcodeFile_GetResult_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      grbl_msgs::action::SendGcodeFile_GetResult_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<grbl_msgs::action::SendGcodeFile_GetResult_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<grbl_msgs::action::SendGcodeFile_GetResult_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<grbl_msgs::action::SendGcodeFile_GetResult_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__grbl_msgs__action__SendGcodeFile_GetResult_Request
    std::shared_ptr<grbl_msgs::action::SendGcodeFile_GetResult_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__grbl_msgs__action__SendGcodeFile_GetResult_Request
    std::shared_ptr<grbl_msgs::action::SendGcodeFile_GetResult_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SendGcodeFile_GetResult_Request_ & other) const
  {
    if (this->goal_id != other.goal_id) {
      return false;
    }
    return true;
  }
  bool operator!=(const SendGcodeFile_GetResult_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SendGcodeFile_GetResult_Request_

// alias to use template instance with default allocator
using SendGcodeFile_GetResult_Request =
  grbl_msgs::action::SendGcodeFile_GetResult_Request_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace grbl_msgs


// Include directives for member types
// Member 'result'
// already included above
// #include "grbl_msgs/action/detail/send_gcode_file__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__grbl_msgs__action__SendGcodeFile_GetResult_Response __attribute__((deprecated))
#else
# define DEPRECATED__grbl_msgs__action__SendGcodeFile_GetResult_Response __declspec(deprecated)
#endif

namespace grbl_msgs
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct SendGcodeFile_GetResult_Response_
{
  using Type = SendGcodeFile_GetResult_Response_<ContainerAllocator>;

  explicit SendGcodeFile_GetResult_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : result(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->status = 0;
    }
  }

  explicit SendGcodeFile_GetResult_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : result(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->status = 0;
    }
  }

  // field types and members
  using _status_type =
    int8_t;
  _status_type status;
  using _result_type =
    grbl_msgs::action::SendGcodeFile_Result_<ContainerAllocator>;
  _result_type result;

  // setters for named parameter idiom
  Type & set__status(
    const int8_t & _arg)
  {
    this->status = _arg;
    return *this;
  }
  Type & set__result(
    const grbl_msgs::action::SendGcodeFile_Result_<ContainerAllocator> & _arg)
  {
    this->result = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    grbl_msgs::action::SendGcodeFile_GetResult_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const grbl_msgs::action::SendGcodeFile_GetResult_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<grbl_msgs::action::SendGcodeFile_GetResult_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<grbl_msgs::action::SendGcodeFile_GetResult_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      grbl_msgs::action::SendGcodeFile_GetResult_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<grbl_msgs::action::SendGcodeFile_GetResult_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      grbl_msgs::action::SendGcodeFile_GetResult_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<grbl_msgs::action::SendGcodeFile_GetResult_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<grbl_msgs::action::SendGcodeFile_GetResult_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<grbl_msgs::action::SendGcodeFile_GetResult_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__grbl_msgs__action__SendGcodeFile_GetResult_Response
    std::shared_ptr<grbl_msgs::action::SendGcodeFile_GetResult_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__grbl_msgs__action__SendGcodeFile_GetResult_Response
    std::shared_ptr<grbl_msgs::action::SendGcodeFile_GetResult_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SendGcodeFile_GetResult_Response_ & other) const
  {
    if (this->status != other.status) {
      return false;
    }
    if (this->result != other.result) {
      return false;
    }
    return true;
  }
  bool operator!=(const SendGcodeFile_GetResult_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SendGcodeFile_GetResult_Response_

// alias to use template instance with default allocator
using SendGcodeFile_GetResult_Response =
  grbl_msgs::action::SendGcodeFile_GetResult_Response_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace grbl_msgs

namespace grbl_msgs
{

namespace action
{

struct SendGcodeFile_GetResult
{
  using Request = grbl_msgs::action::SendGcodeFile_GetResult_Request;
  using Response = grbl_msgs::action::SendGcodeFile_GetResult_Response;
};

}  // namespace action

}  // namespace grbl_msgs


// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__struct.hpp"
// Member 'feedback'
// already included above
// #include "grbl_msgs/action/detail/send_gcode_file__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__grbl_msgs__action__SendGcodeFile_FeedbackMessage __attribute__((deprecated))
#else
# define DEPRECATED__grbl_msgs__action__SendGcodeFile_FeedbackMessage __declspec(deprecated)
#endif

namespace grbl_msgs
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct SendGcodeFile_FeedbackMessage_
{
  using Type = SendGcodeFile_FeedbackMessage_<ContainerAllocator>;

  explicit SendGcodeFile_FeedbackMessage_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : goal_id(_init),
    feedback(_init)
  {
    (void)_init;
  }

  explicit SendGcodeFile_FeedbackMessage_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : goal_id(_alloc, _init),
    feedback(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _goal_id_type =
    unique_identifier_msgs::msg::UUID_<ContainerAllocator>;
  _goal_id_type goal_id;
  using _feedback_type =
    grbl_msgs::action::SendGcodeFile_Feedback_<ContainerAllocator>;
  _feedback_type feedback;

  // setters for named parameter idiom
  Type & set__goal_id(
    const unique_identifier_msgs::msg::UUID_<ContainerAllocator> & _arg)
  {
    this->goal_id = _arg;
    return *this;
  }
  Type & set__feedback(
    const grbl_msgs::action::SendGcodeFile_Feedback_<ContainerAllocator> & _arg)
  {
    this->feedback = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    grbl_msgs::action::SendGcodeFile_FeedbackMessage_<ContainerAllocator> *;
  using ConstRawPtr =
    const grbl_msgs::action::SendGcodeFile_FeedbackMessage_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<grbl_msgs::action::SendGcodeFile_FeedbackMessage_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<grbl_msgs::action::SendGcodeFile_FeedbackMessage_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      grbl_msgs::action::SendGcodeFile_FeedbackMessage_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<grbl_msgs::action::SendGcodeFile_FeedbackMessage_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      grbl_msgs::action::SendGcodeFile_FeedbackMessage_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<grbl_msgs::action::SendGcodeFile_FeedbackMessage_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<grbl_msgs::action::SendGcodeFile_FeedbackMessage_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<grbl_msgs::action::SendGcodeFile_FeedbackMessage_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__grbl_msgs__action__SendGcodeFile_FeedbackMessage
    std::shared_ptr<grbl_msgs::action::SendGcodeFile_FeedbackMessage_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__grbl_msgs__action__SendGcodeFile_FeedbackMessage
    std::shared_ptr<grbl_msgs::action::SendGcodeFile_FeedbackMessage_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SendGcodeFile_FeedbackMessage_ & other) const
  {
    if (this->goal_id != other.goal_id) {
      return false;
    }
    if (this->feedback != other.feedback) {
      return false;
    }
    return true;
  }
  bool operator!=(const SendGcodeFile_FeedbackMessage_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SendGcodeFile_FeedbackMessage_

// alias to use template instance with default allocator
using SendGcodeFile_FeedbackMessage =
  grbl_msgs::action::SendGcodeFile_FeedbackMessage_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace grbl_msgs

#include "action_msgs/srv/cancel_goal.hpp"
#include "action_msgs/msg/goal_info.hpp"
#include "action_msgs/msg/goal_status_array.hpp"

namespace grbl_msgs
{

namespace action
{

struct SendGcodeFile
{
  /// The goal message defined in the action definition.
  using Goal = grbl_msgs::action::SendGcodeFile_Goal;
  /// The result message defined in the action definition.
  using Result = grbl_msgs::action::SendGcodeFile_Result;
  /// The feedback message defined in the action definition.
  using Feedback = grbl_msgs::action::SendGcodeFile_Feedback;

  struct Impl
  {
    /// The send_goal service using a wrapped version of the goal message as a request.
    using SendGoalService = grbl_msgs::action::SendGcodeFile_SendGoal;
    /// The get_result service using a wrapped version of the result message as a response.
    using GetResultService = grbl_msgs::action::SendGcodeFile_GetResult;
    /// The feedback message with generic fields which wraps the feedback message.
    using FeedbackMessage = grbl_msgs::action::SendGcodeFile_FeedbackMessage;

    /// The generic service to cancel a goal.
    using CancelGoalService = action_msgs::srv::CancelGoal;
    /// The generic message for the status of a goal.
    using GoalStatusMessage = action_msgs::msg::GoalStatusArray;
  };
};

typedef struct SendGcodeFile SendGcodeFile;

}  // namespace action

}  // namespace grbl_msgs

#endif  // GRBL_MSGS__ACTION__DETAIL__SEND_GCODE_FILE__STRUCT_HPP_
