// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from grbl_msgs:srv/Stop.idl
// generated code does not contain a copyright notice

#ifndef GRBL_MSGS__SRV__DETAIL__STOP__FUNCTIONS_H_
#define GRBL_MSGS__SRV__DETAIL__STOP__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/visibility_control.h"
#include "grbl_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "grbl_msgs/srv/detail/stop__struct.h"

/// Initialize srv/Stop message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * grbl_msgs__srv__Stop_Request
 * )) before or use
 * grbl_msgs__srv__Stop_Request__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_grbl_msgs
bool
grbl_msgs__srv__Stop_Request__init(grbl_msgs__srv__Stop_Request * msg);

/// Finalize srv/Stop message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_grbl_msgs
void
grbl_msgs__srv__Stop_Request__fini(grbl_msgs__srv__Stop_Request * msg);

/// Create srv/Stop message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * grbl_msgs__srv__Stop_Request__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_grbl_msgs
grbl_msgs__srv__Stop_Request *
grbl_msgs__srv__Stop_Request__create();

/// Destroy srv/Stop message.
/**
 * It calls
 * grbl_msgs__srv__Stop_Request__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_grbl_msgs
void
grbl_msgs__srv__Stop_Request__destroy(grbl_msgs__srv__Stop_Request * msg);


/// Initialize array of srv/Stop messages.
/**
 * It allocates the memory for the number of elements and calls
 * grbl_msgs__srv__Stop_Request__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_grbl_msgs
bool
grbl_msgs__srv__Stop_Request__Sequence__init(grbl_msgs__srv__Stop_Request__Sequence * array, size_t size);

/// Finalize array of srv/Stop messages.
/**
 * It calls
 * grbl_msgs__srv__Stop_Request__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_grbl_msgs
void
grbl_msgs__srv__Stop_Request__Sequence__fini(grbl_msgs__srv__Stop_Request__Sequence * array);

/// Create array of srv/Stop messages.
/**
 * It allocates the memory for the array and calls
 * grbl_msgs__srv__Stop_Request__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_grbl_msgs
grbl_msgs__srv__Stop_Request__Sequence *
grbl_msgs__srv__Stop_Request__Sequence__create(size_t size);

/// Destroy array of srv/Stop messages.
/**
 * It calls
 * grbl_msgs__srv__Stop_Request__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_grbl_msgs
void
grbl_msgs__srv__Stop_Request__Sequence__destroy(grbl_msgs__srv__Stop_Request__Sequence * array);

/// Initialize srv/Stop message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * grbl_msgs__srv__Stop_Response
 * )) before or use
 * grbl_msgs__srv__Stop_Response__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_grbl_msgs
bool
grbl_msgs__srv__Stop_Response__init(grbl_msgs__srv__Stop_Response * msg);

/// Finalize srv/Stop message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_grbl_msgs
void
grbl_msgs__srv__Stop_Response__fini(grbl_msgs__srv__Stop_Response * msg);

/// Create srv/Stop message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * grbl_msgs__srv__Stop_Response__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_grbl_msgs
grbl_msgs__srv__Stop_Response *
grbl_msgs__srv__Stop_Response__create();

/// Destroy srv/Stop message.
/**
 * It calls
 * grbl_msgs__srv__Stop_Response__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_grbl_msgs
void
grbl_msgs__srv__Stop_Response__destroy(grbl_msgs__srv__Stop_Response * msg);


/// Initialize array of srv/Stop messages.
/**
 * It allocates the memory for the number of elements and calls
 * grbl_msgs__srv__Stop_Response__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_grbl_msgs
bool
grbl_msgs__srv__Stop_Response__Sequence__init(grbl_msgs__srv__Stop_Response__Sequence * array, size_t size);

/// Finalize array of srv/Stop messages.
/**
 * It calls
 * grbl_msgs__srv__Stop_Response__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_grbl_msgs
void
grbl_msgs__srv__Stop_Response__Sequence__fini(grbl_msgs__srv__Stop_Response__Sequence * array);

/// Create array of srv/Stop messages.
/**
 * It allocates the memory for the array and calls
 * grbl_msgs__srv__Stop_Response__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_grbl_msgs
grbl_msgs__srv__Stop_Response__Sequence *
grbl_msgs__srv__Stop_Response__Sequence__create(size_t size);

/// Destroy array of srv/Stop messages.
/**
 * It calls
 * grbl_msgs__srv__Stop_Response__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_grbl_msgs
void
grbl_msgs__srv__Stop_Response__Sequence__destroy(grbl_msgs__srv__Stop_Response__Sequence * array);

#ifdef __cplusplus
}
#endif

#endif  // GRBL_MSGS__SRV__DETAIL__STOP__FUNCTIONS_H_
